/* ENG is Not a Game (c) Thunor 2008 <thunorsif@hotmail.com>
www.thunor.org.uk

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */


/* Includes */
#include "ENG_engine.h"


/* Defines */
/*
#define DEBUG_IMAGES
#define DEBUG_IMAGE_SORT
#define DEBUG_IMAGE_BINARY_SEARCH
*/

#define ENG_MAX_IMAGES 1000

#define ENG_IMG_TESTCARD_W 32
#define ENG_IMG_TESTCARD_H 32
#define ENG_IMG_TESTCARD_FILLS 42
#define ENG_IMG_POINTER_FILLS 23 * 2
#define ENG_IMG_POINTER_SHADOW_FILLS 23
#define ENG_IMG_EXIT_FILLS 19
#define ENG_IMG_MINIMISE_FILLS 6
#define ENG_IMG_RESTORE_FILLS 12
#define ENG_IMG_MAXIMISE_FILLS 7


/* Variables */
ENG_Image *eng_images[ENG_MAX_IMAGES];
int eng_image_count = 0;


/* Data */
int img_testcard[7 * ENG_IMG_TESTCARD_FILLS]={
/*
x	y	w	h	rgb */
0,	0,	32,	32,	0xff, 0xff, 0xff,
1,	1,	30,	30,	0, 0, 0,
2,	2,	14,	14,	0xff, 0xff, 0xff,
9,	9,	6,	6,	0xcc, 0xcc, 0xcc,
3,	9,	6,	6,	0x99, 0x99, 0x99,
3,	3,	6,	6,	0x66, 0x66, 0x66,
9,	3,	6,	6,	0x33, 0x33, 0x33,
10,	10,	2,	2,	0xff, 0xff, 0xff,
12,	10,	2,	2,	0x99, 0x99, 0x99,
12,	12,	2,	2,	0x66, 0x66, 0x66,
10,	12,	2,	2,	0x33, 0x33, 0x33,
16,	2,	14,	14,	0xff, 0, 0,
17,	9,	6,	6,	0xcc, 0, 0,
17,	3,	6,	6,	0x99, 0, 0,
23,	3,	6,	6,	0x66, 0, 0,
23,	9,	6,	6,	0x33, 0, 0,
20,	10,	2,	2,	0xff, 0, 0,
20,	12,	2,	2,	0x99, 0, 0,
18,	12,	2,	2,	0x66, 0, 0,
18,	10,	2,	2,	0x33, 0, 0,
16,	16,	14,	14,	0, 0xff, 0,
17,	17,	6,	6,	0, 0xcc, 0,
23,	17,	6,	6,	0, 0x99, 0,
23,	23,	6,	6,	0, 0x66, 0,
17,	23,	6,	6,	0, 0x33, 0,
20,	20,	2,	2,	0, 0xff, 0,
18,	20,	2,	2,	0, 0x99, 0,
18,	18,	2,	2,	0, 0x66, 0,
20,	18,	2,	2,	0, 0x33, 0,
2,	16,	14,	14,	0, 0, 0xff,
9,	17,	6,	6,	0, 0, 0xcc,
9,	23,	6,	6,	0, 0, 0x99,
3,	23,	6,	6,	0, 0, 0x66,
3,	17,	6,	6,	0, 0, 0x33,
10,	20,	2,	2,	0, 0, 0xff,
10,	18,	2,	2,	0, 0, 0x99,
12,	18,	2,	2,	0, 0, 0x66,
12,	20,	2,	2,	0, 0, 0x33};

int img_pointer_shadow[7 * ENG_IMG_POINTER_SHADOW_FILLS]={
/*
x	y	w	h	rgb */
0, 	0, 	13, 19, ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
0, 	0, 	2, 	1, 	0, 0, 0,
0, 	1, 	3, 	1, 	0, 0, 0,
0, 	2, 	4, 	1, 	0, 0, 0,
0, 	3, 	5, 	1, 	0, 0, 0,
0, 	4, 	6, 	1, 	0, 0, 0,
0, 	5, 	7, 	1, 	0, 0, 0,
0, 	6, 	8, 	1, 	0, 0, 0,
0, 	7, 	9, 	1, 	0, 0, 0,
0, 	8, 	10, 1, 	0, 0, 0,
0, 	9, 	11, 1, 	0, 0, 0,
0, 	10, 12, 1, 	0, 0, 0,
0, 	11, 13, 1, 	0, 0, 0,
0, 	12, 8, 	1, 	0, 0, 0,
0, 	13, 3, 	1, 	0, 0, 0,
4, 	13, 5, 	1, 	0, 0, 0,
0, 	14, 2, 	1, 	0, 0, 0,
4, 	14, 5, 	1, 	0, 0, 0,
0, 	15, 1, 	1, 	0, 0, 0,
5, 	15, 5, 	1, 	0, 0, 0,
5, 	16, 5, 	1, 	0, 0, 0,
6, 	17, 4, 	1, 	0, 0, 0,
6, 	18, 3, 	1, 	0, 0, 0};

int img_pointer[7 * ENG_IMG_POINTER_FILLS]={
/*
x	y	w	h	rgb */
0, 	0, 	13, 19, ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
0, 	0, 	2, 	1, 	0, 0, 0,
0, 	1, 	3, 	1, 	0, 0, 0,
0, 	2, 	4, 	1, 	0, 0, 0,
0, 	3, 	5, 	1, 	0, 0, 0,
0, 	4, 	6, 	1, 	0, 0, 0,
0, 	5, 	7, 	1, 	0, 0, 0,
0, 	6, 	8, 	1, 	0, 0, 0,
0, 	7, 	9, 	1, 	0, 0, 0,
0, 	8, 	10, 1, 	0, 0, 0,
0, 	9, 	11, 1, 	0, 0, 0,
0, 	10, 12, 1, 	0, 0, 0,
0, 	11, 13, 1, 	0, 0, 0,
0, 	12, 8, 	1, 	0, 0, 0,
0, 	13, 3, 	1, 	0, 0, 0,
4, 	13, 5, 	1, 	0, 0, 0,
0, 	14, 2, 	1, 	0, 0, 0,
4, 	14, 5, 	1, 	0, 0, 0,
0, 	15, 1, 	1, 	0, 0, 0,
5, 	15, 5, 	1, 	0, 0, 0,
5, 	16, 5, 	1, 	0, 0, 0,
6, 	17, 4, 	1, 	0, 0, 0,
6, 	18, 3, 	1, 	0, 0, 0,
0, 	0, 	1, 	16, 0xff, 0xff, 0xff,
1, 	0, 	1, 	1, 	0xff, 0xff, 0xff,
1, 	14, 1, 	1, 	0xff, 0xff, 0xff,
2, 	1, 	1, 	1, 	0xff, 0xff, 0xff,
2, 	13, 1, 	1, 	0xff, 0xff, 0xff,
3, 	2, 	1, 	1, 	0xff, 0xff, 0xff,
3, 	12, 1, 	1, 	0xff, 0xff, 0xff,
4, 	3, 	1, 	1, 	0xff, 0xff, 0xff,
4, 	13, 1, 	2, 	0xff, 0xff, 0xff,
5, 	4, 	1, 	1, 	0xff, 0xff, 0xff,
5, 	15, 1, 	2, 	0xff, 0xff, 0xff,
6, 	5, 	1, 	1, 	0xff, 0xff, 0xff,
6, 	17, 1, 	2, 	0xff, 0xff, 0xff,
7, 	6, 	1, 	1, 	0xff, 0xff, 0xff,
7, 	11, 1, 	2, 	0xff, 0xff, 0xff,
7, 	18, 2, 	1, 	0xff, 0xff, 0xff,
8, 	7, 	1, 	1, 	0xff, 0xff, 0xff,
8, 	11, 5, 	1, 	0xff, 0xff, 0xff,
8, 	13, 1, 	2, 	0xff, 0xff, 0xff,
9, 	8, 	1, 	1, 	0xff, 0xff, 0xff,
9, 	15, 1, 	3, 	0xff, 0xff, 0xff,
10, 9, 	1, 	1, 	0xff, 0xff, 0xff,
11, 10, 1, 	1, 	0xff, 0xff, 0xff};

int img_blank[7]={
/*
x	y	w	h	rgb */
0,	0,	0,	0,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE};

int img_exit[7 * ENG_IMG_EXIT_FILLS]={
/*
x	y	w	h	rgb */
0,	0,	24,	14,	0xff, 0xff, 0xff,
0,	0,	1,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
23,	0,	1,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
23,	13,	1,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
0,	13,	1,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
1,	1,	7,	12,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
16,	1,	7,	12,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
7,	1,	10,	2,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
7,	11,	10,	2,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
10,	3,	4,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
11,	4,	2,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
11,	9,	2,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
10,	10,	4,	1,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
7,	4,	1,	6,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
8,	5,	1,	4,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
9,	6,	1,	2,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
14,	6,	1,	2,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
15,	5,	1,	4,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
16,	4,	1,	6,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE};

int img_minimise[7 * ENG_IMG_MINIMISE_FILLS]={
/*
x	y	w	h	rgb */
0,	0,	24,	14,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
1,	0,	22,	1,	0xff, 0xff, 0xff,
1,	13,	22,	1,	0xff, 0xff, 0xff,
0,	1,	1,	12,	0xff, 0xff, 0xff,
23,	1,	1,	12,	0xff, 0xff, 0xff,
8,	9,	8,	2,	0xff, 0xff, 0xff};

int img_restore[7 * ENG_IMG_RESTORE_FILLS]={
/*
x	y	w	h	rgb */
0,	0,	24,	14,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
1,	0,	22,	1,	0xff, 0xff, 0xff,
1,	13,	22,	1,	0xff, 0xff, 0xff,
0,	1,	1,	12,	0xff, 0xff, 0xff,
23,	1,	1,	12,	0xff, 0xff, 0xff,
10,	3,	7,	2,	0xff, 0xff, 0xff,
16,	5,	1,	3,	0xff, 0xff, 0xff,
15,	7,	1,	1,	0xff, 0xff, 0xff,
7,	6,	7,	2,	0xff, 0xff, 0xff,
7,	8,	1,	3,	0xff, 0xff, 0xff,
13,	8,	1,	3,	0xff, 0xff, 0xff,
8,	10,	5,	1,	0xff, 0xff, 0xff};

int img_maximise[7 * ENG_IMG_MAXIMISE_FILLS]={
/*
x	y	w	h	rgb */
0,	0,	24,	14,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE,
1,	0,	22,	1,	0xff, 0xff, 0xff,
1,	13,	22,	1,	0xff, 0xff, 0xff,
0,	1,	1,	12,	0xff, 0xff, 0xff,
23,	1,	1,	12,	0xff, 0xff, 0xff,
8,	3,	8,	8,	0xff, 0xff, 0xff,
9,	5,	6,	5,	ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE};


/* Function prototypes */
int ENG_CreateImageFromFills(ENG_Image *image, int w, int h, int xscale, int yscale, int *fillarray, int fillcount);


/***************************************************************************
 * Initialise Images                                                       *
 ***************************************************************************/

void ENG_InitImages(void) {
}

/***************************************************************************
 * Get Image                                                               *
 ***************************************************************************/
/* On entry: img_file points to the filename of the image
	On exit: returns a pointer to an image on success else NULL */

ENG_Image *ENG_GetImage(char *img_file) {
	int top = eng_image_count - 1, middle = 0, bottom = 0;
	int result = TRUE;

	#ifdef DEBUG_IMAGE_BINARY_SEARCH
		printf("%s: Searching for %s :-\n", __func__, img_file);
	#endif
	/* Binary search for img_file */
	while (bottom <= top) {
		middle = (bottom + top) / 2;
		result = strcmp(eng_images[middle]->img_file, img_file);
		#ifdef DEBUG_IMAGE_BINARY_SEARCH
			printf("    b=%i m=%i t=%i: Comparing %s to %s: result=%i\n", bottom, middle, top, eng_images[middle]->img_file, img_file, result);
		#endif
		if (result == 0) {
			#ifdef DEBUG_IMAGE_BINARY_SEARCH
				printf("    %s found\n", img_file);
			#endif
			return eng_images[middle];
		} else if (result < 0) {
			bottom = middle + 1;
		} else {
			top = middle - 1;
		}
	}
	#ifdef DEBUG_IMAGE_BINARY_SEARCH
		printf("    %s not found\n", img_file);
	#endif
	
	/* int count;

	/$ Linear search for img_file $/
	for (count = 0; count < eng_image_count; count++) {
		if (!strcmp(eng_images[count]->img_file, img_file)) return eng_images[count];
	} */

	return NULL;
}

/***************************************************************************
 * Create Image                                                            *
 ***************************************************************************/
/* Images are converted to the same format as the screen surface and use
   the ENG system colour key.
   
   On entry: image->img_file is the image to load or create
			 ignore_image_dir will ignore eng_op_env.image_dir when loading
			 w and h are the width and heigth of an imgASCIIText surface */

/*  On exit: returns ENG_ERROR_NONE on success else
			 any one of the error codes in ENG.h */

int ENG_CreateImage(ENG_Image *image, int ignore_image_dir, int w, int h, int img_set_colour_key, int img_use_rleaccel) {
	int retval = ENG_ERROR_NONE, swapped, count;
	ENG_Image *newimage, *swapimage;
	char path[ENG_PATH_LENGTH + ENG_FILE_LENGTH];
	SDL_Surface *converted;
	Uint32 bgcolour;

	if (image == NULL || sizeof(*image) != sizeof(ENG_Image)) {
		sprintf(eng_last_error, "%s: image is invalid", __func__);
		retval = ENG_ERROR_INVALID_IMAGE;
	} else if (eng_image_count >= ENG_MAX_IMAGES) {
		sprintf(eng_last_error, "%s: Too many images (max %i)", __func__, ENG_MAX_IMAGES);
		retval = ENG_ERROR_TOO_MANY_IMAGES;
	} else {
		newimage = (ENG_Image*) malloc(sizeof(ENG_Image));
		*newimage = *image;
		#ifdef DEBUG_IMAGES
			printf("%s: Creating %p (%s)\n", __func__, newimage, newimage->img_file);
		#endif
		eng_images[eng_image_count] = newimage;
		eng_image_count++;
		/* Load (or create) the bmp and attach it to the image */
		if (!strncmp(newimage->img_file, ENG_IMG_TESTCARD, strlen(ENG_IMG_TESTCARD))) {
			/* ENG_IMG_TESTCARD doesn't exist so we'll create it from fills */
			retval = ENG_CreateImageFromFills(newimage, ENG_IMG_TESTCARD_W, ENG_IMG_TESTCARD_H, ceil(w / (float)ENG_IMG_TESTCARD_W), ceil(h / (float)ENG_IMG_TESTCARD_H), img_testcard, ENG_IMG_TESTCARD_FILLS);
		} else if (!strncmp(newimage->img_file, ENG_IMG_BLANK, strlen(ENG_IMG_BLANK))) {
			/* ENG_IMG_BLANK doesn't exist so we'll create it from fills */
			img_blank[2] = w; img_blank[3] = h;
			retval = ENG_CreateImageFromFills(newimage, w, h, 1, 1, img_blank, 1);
		} else if (!strcmp(newimage->img_file, ENG_IMG_POINTER_SHADOW)) {
			/* ENG_IMG_POINTER_SHADOW doesn't exist so we'll create it from fills */
			retval = ENG_CreateImageFromFills(newimage, ENG_IMG_POINTER_W, ENG_IMG_POINTER_H, 1, 1, img_pointer_shadow, ENG_IMG_POINTER_SHADOW_FILLS);
		} else if (!strcmp(newimage->img_file, ENG_IMG_POINTER)) {
			/* ENG_IMG_POINTER doesn't exist so we'll create it from fills */
			retval = ENG_CreateImageFromFills(newimage, ENG_IMG_POINTER_W, ENG_IMG_POINTER_H, 1, 1, img_pointer, ENG_IMG_POINTER_FILLS);
		} else if (!strcmp(newimage->img_file, ENG_IMG_EXIT)) {
			/* ENG_IMG_EXIT doesn't exist so we'll create it from fills */
			retval = ENG_CreateImageFromFills(newimage, ENG_IMG_EXIT_W, ENG_IMG_EXIT_H, 1, 1, img_exit, ENG_IMG_EXIT_FILLS);
		} else if (!strcmp(newimage->img_file, ENG_IMG_MINIMISE)) {
			/* ENG_IMG_MINIMISE doesn't exist so we'll create it from fills */
			retval = ENG_CreateImageFromFills(newimage, ENG_IMG_MINIMISE_W, ENG_IMG_MINIMISE_H, 1, 1, img_minimise, ENG_IMG_MINIMISE_FILLS);
		} else if (!strcmp(newimage->img_file, ENG_IMG_RESTORE)) {
			/* ENG_IMG_RESTORE doesn't exist so we'll create it from fills */
			retval = ENG_CreateImageFromFills(newimage, ENG_IMG_RESTORE_W, ENG_IMG_RESTORE_H, 1, 1, img_restore, ENG_IMG_RESTORE_FILLS);
		} else if (!strcmp(newimage->img_file, ENG_IMG_MAXIMISE)) {
			/* ENG_IMG_MAXIMISE doesn't exist so we'll create it from fills */
			retval = ENG_CreateImageFromFills(newimage, ENG_IMG_MAXIMISE_W, ENG_IMG_MAXIMISE_H, 1, 1, img_maximise, ENG_IMG_MAXIMISE_FILLS);
		} else {
			/* Build a path to the file and load it */
			strcpy(path, "");
			if (!ignore_image_dir) {
				strcat(path, eng_op_env.image_dir);
				if (strlen(path) > 0 && path[strlen(path) - 1] != '/') strcat(path, "/");
			}
			strcat(path, newimage->img_file);
			newimage->img_surface = SDL_LoadBMP(path);
			if (newimage->img_surface == NULL) {
				/* No surface so free image (ignoring errors) */
				ENG_FreeImage(newimage);
				sprintf(eng_last_error, "%s: %s not found: %s", __func__, path, SDL_GetError());
				retval = ENG_ERROR_CANNOT_OPEN_IMAGE_FILE;
			}
		}
		if (!retval) {
			if (img_set_colour_key || img_use_rleaccel) {
				/* Set the colour key and/or RLE acceleration for the new surface */
				bgcolour = SDL_MapRGB(newimage->img_surface->format, ENG_COLOUR_KEY_RED, ENG_COLOUR_KEY_GREEN, ENG_COLOUR_KEY_BLUE);
				if ((SDL_SetColorKey(newimage->img_surface, (SDL_SRCCOLORKEY * img_set_colour_key) | (SDL_RLEACCEL * img_use_rleaccel), bgcolour)) < 0) {
					sprintf(eng_last_error, "%s: Cannot set surface colour key and/or RLE acceleration: %s", __func__, SDL_GetError());
					retval = ENG_ERROR_CANNOT_SET_COLOUR_KEY;
				}
			}
		}
		if (!retval) {
			/* Convert the new surface to the same format as the screen */
			converted = SDL_DisplayFormat(newimage->img_surface);
			if (converted == NULL) {
				sprintf(eng_last_error, "%s: Cannot create surface: %s", __func__, SDL_GetError());
				retval = ENG_ERROR_CANNOT_CREATE_SURFACE;
			} else {
				SDL_FreeSurface(newimage->img_surface);
				newimage->img_surface = converted;
			}
		}
		if (!retval) {
			/* Bubble sort eng_images for later binary search */
			do {
				swapped = FALSE;
				for (count = 0; count < eng_image_count - 1; count++) {
					if (strcmp(eng_images[count]->img_file, eng_images[count + 1]->img_file) > 0) {
						swapped = TRUE;
						swapimage = eng_images[count];
						eng_images[count] = eng_images[count + 1];
						eng_images[count + 1] = swapimage;
					}
				}
			} while (swapped);
		}
	}

	return retval;
}

/***************************************************************************
 * Create Image From Fills                                                 *
 ***************************************************************************/
/* This is used to create inbuilt images from fills. The testcard image and
   the pointer and shadow are created using this method amongst others */

/*  On exit: returns ENG_ERROR_NONE on success else
			 any one of the error codes in ENG.h */

int ENG_CreateImageFromFills(ENG_Image *image, int w, int h, int xscale, int yscale, int *fillarray, int fillcount) {
	int retval = ENG_ERROR_NONE, count;
	SDL_Rect dstrect;
	Uint32 bgcolour = 0;

	image->img_surface = SDL_CreateRGBSurface(eng_screen->flags, w * xscale, h * yscale, eng_screen->format->BitsPerPixel, eng_screen->format->Rmask, eng_screen->format->Gmask, eng_screen->format->Bmask, eng_screen->format->Amask);
	if (image->img_surface == NULL) {
		sprintf(eng_last_error, "%s: Cannot create surface: %s", __func__, SDL_GetError());
		retval = ENG_ERROR_CANNOT_CREATE_SURFACE;
	}
	if (!retval) {
		/* Create the image using fills */
		for (count = 0; count < fillcount; count++) {
			dstrect.x = fillarray[count * 7] * xscale;
			dstrect.y = fillarray[count * 7 + 1] * yscale;
			dstrect.w = fillarray[count * 7 + 2] * xscale;
			dstrect.h = fillarray[count * 7 + 3] * yscale;
			bgcolour = SDL_MapRGB(image->img_surface->format, fillarray[count * 7 + 4], fillarray[count * 7 + 5], fillarray[count * 7 + 6]);
			if ((SDL_FillRect(image->img_surface, &dstrect, bgcolour)) < 0) {
				sprintf(eng_last_error, "%s: Cannot fill surface: %s", __func__, SDL_GetError());
				retval = ENG_ERROR_CANNOT_FILL_SURFACE;
				break;
			}
		}
	}

	return retval;
}

/***************************************************************************
 * Free Image                                                              *
 ***************************************************************************/
/*  On exit: returns ENG_ERROR_NONE on success else
			 any one of the error codes in ENG.h */

int ENG_FreeImage(ENG_Image *image) {
	int retval = ENG_ERROR_NONE, count, count2;
	
	if (eng_image_count <= 0) {
		sprintf(eng_last_error, "%s: There is no image to free", __func__);
		retval = ENG_ERROR_INVALID_IMAGE;
	} else if (image == NULL || sizeof(*image) != sizeof(ENG_Image)) {
		sprintf(eng_last_error, "%s: image is invalid", __func__);
		retval = ENG_ERROR_INVALID_IMAGE;
	} else if (eng_run && (!strcmp(image->img_file, ENG_IMG_POINTER) || !strcmp(image->img_file, ENG_IMG_POINTER_SHADOW) ||
				!strcmp(image->img_file, ENG_IMG_EXIT) || !strcmp(image->img_file, ENG_IMG_MINIMISE) ||
				!strcmp(image->img_file, ENG_IMG_RESTORE) || !strcmp(image->img_file, ENG_IMG_MAXIMISE) ||
				!strcmp(image->img_file, ENG_IMG_CPS_TEXT))) {
		sprintf(eng_last_error, "%s: image is invalid", __func__);
		retval = ENG_ERROR_INVALID_IMAGE;
	} else {
		#ifdef DEBUG_IMAGES
			printf("%s: Freeing %p (%s)\n", __func__, image, image->img_file);
		#endif
		/* If anything is above the current image then move it down */
		for (count = 0; count < eng_image_count - 1; count++) {
			if (eng_images[count] == image) {
				for (count2 = count; count2 < eng_image_count - 1; count2++) {
					eng_images[count2] = eng_images[count2 + 1];
				}
				break;				
			}
		}
		/* Free the memory and update the array element count now */
		if (image->img_surface != NULL) SDL_FreeSurface(image->img_surface);
		free(image);
		eng_image_count--;
	}

	return retval;
}

/***************************************************************************
 * Free All Images                                                         *
 ***************************************************************************/
/* This mops-up any remaining images before shutting down */

void ENG_FreeAllImages(void) {
	int count;
	
	if (eng_image_count > 0) {
		printf("%s: Freeing\n", __func__);
		/* Free all remaining images (ignoring errors) */
		for (count = eng_image_count - 1; count >= 0; count--) {
			ENG_FreeImage(eng_images[count]);
		}
	}
}



