/* Tetravex (c) Thunor 2008 <thunorsif@hotmail.com>
www.thunor.org.uk

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */


/* Includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "main.h"


/* Defines */
/* Tetravex key object ids */
#define LYR_TETRAVEX 1000
#define REC_TETRAVEX_EXIT 1001

#define HISCORES_MAX 5


/***************************************************************************
 * Tetravex Hi-Scores New Event Processor                                  *
 ***************************************************************************/

void tetravex_hiscores_new_event_processor(ENG_Event *event) {
	static char objects_file[ENG_PATH_LENGTH];
	static char last_game_played[ENG_CONFIG_OPTION_VALUE_LENGTH];
	
	/* Process events */
	switch (event->klasse) {
		case ENG_EVENT_CYCLE:
			break;
		case ENG_EVENT_OVER:
			break;
		case ENG_EVENT_OUT:
			break;
		case ENG_EVENT_PRESS:
			break;
		case ENG_EVENT_CLICK:
			if (event->object->id == LYR_TETRAVEX) {
			} else if (event->object->id == REC_TETRAVEX_EXIT) {


				/* Change the event processor to tetravex_?x? */
				if (!strcmp(last_game_played, "3x3")) {
					op_env.event_processor = &tetravex_3x3_event_processor;
				} else {
					op_env.event_processor = &tetravex_4x4_event_processor;
				}
				if (ENG_SetOpEnvEventProcessor(op_env.event_processor)) printf("%s: %s\n", __func__, ENG_GetError());
				/* Unload the tetravex_hiscores_new objects file */
				if (ENG_UnloadObjects(objects_file)) printf("%s: %s\n", __func__, ENG_GetError());

			}
			break;
		case ENG_EVENT_QUITTING:
			break;
		case ENG_EVENT_POST_LOAD_OBJECTS:
			/* Store the objects_file so we know what to unload */
			strcpy(objects_file, ENG_GetObject(LYR_TETRAVEX)->objects_file);

			/* Retrieve tetravex.last_game_played (this will have been set) */
			if (ENG_GetConfigOption("tetravex.last_game_played", last_game_played)) printf("%s: %s\n", __func__, ENG_GetError());


			break;
		case ENG_EVENT_UP:
			break;
		case ENG_EVENT_UP_RIGHT:
			break;
		case ENG_EVENT_RIGHT:
			break;
		case ENG_EVENT_DOWN_RIGHT:
			break;
		case ENG_EVENT_DOWN:
			break;
		case ENG_EVENT_DOWN_LEFT:
			break;
		case ENG_EVENT_LEFT:
			break;
		case ENG_EVENT_UP_LEFT:
			break;
		case ENG_EVENT_SELECT:
			break;
		case ENG_EVENT_SHUTDOWN:
			ENG_Quit();
			break;
		case ENG_EVENT_TOGGLE_FULLSCREEN:
			op_env.fullscreen = 1 - op_env.fullscreen;
			if (ENG_SetOpEnvFullScreen(op_env.fullscreen)) printf("%s: %s\n", __func__, ENG_GetError());
			break;
		case ENG_EVENT_MODIFIER1:
			break;
		case ENG_EVENT_MODIFIER2:
			break;
	}

}







